<script lang="ts" setup>
import type { PropType } from 'vue';
import {
  CollaborationAlt4,
  UserChatAlt,
  Code,
  Event,
  World,
  ChatBubble,
  BulbBolt,
  RemoteChat,
  ArrowRight,
  GitlabCd,
  HandbookGitlab,
  OpenSource,
  Group,
  Access,
  Collaboration,
  Community,
  Handshake,
  DocsAlt,
  AiReviewerSuggestions,
  Documents,
  AccelerateThin,
  IdeaCollaboration,
  GitlabMonitorAlt,
} from 'slippers-ui/icons';
import type { BaseCard } from '@/types/base';

const icons = {
  CollaborationAlt4,
  RemoteChat,
  UserChatAlt,
  BulbBolt,
  ChatBubble,
  Code,
  Event,
  World,
  GitlabCd,
  HandbookGitlab,
  OpenSource,
  Group,
  Access,
  Collaboration,
  Community,
  Handshake,
  DocsAlt,
  AiReviewerSuggestions,
  Documents,
  AccelerateThin,
  IdeaCollaboration,
  GitlabMonitorAlt,
};

defineProps({
  header: { type: String, required: true },
  cards: {
    type: Object as PropType<BaseCard[]>,
    required: true,
  },
});
</script>

<template>
  <SlpContainer class="wrapper slp-mb-48">
    <SlpTypography variant="heading2-bold" class="slp-mb-32" tag="h2">
      {{ header }}
    </SlpTypography>
    <div class="solution-grid">
      <a
        v-for="card in cards"
        :key="card.title"
        class="solution-card"
        :href="card.button?.config.href"
        :data-ga-name="card.title"
        data-ga-location="by solution"
      >
        <div class="header">
          <SlpIcon :icon="icons[card.config.icon]" size="lg" />
          <SlpTypography variant="heading5-bold">
            {{ card.title }}
          </SlpTypography>
        </div>
        <SlpTypography variant="body3">
          {{ card.description }}
        </SlpTypography>
        <SlpIcon class="arrow-icon" :icon="ArrowRight" variant="product" size="sm" />
      </a>
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.solution-grid {
  display: grid;
  margin-top: 24px;
  grid-template-columns: 1fr;
  gap: 16px;
  @media (min-width: $breakpoint-lg) {
    grid-template-columns: repeat(4, 1fr);
    gap: 32px;
  }
  .solution-card {
    cursor: pointer;
    display: flex;
    color: $color-text-300;
    flex-direction: column;
    gap: 24px;
    padding: 24px;
    background-color: $color-surface-800;
    min-height: 250px;
    border-radius: 4px;
    transition: all 0.3s;
    .header {
      display: flex;
      flex-direction: column;
      gap: 16px;
    }
    .arrow-icon {
      margin-top: auto;
    }
    &:hover {
      border-radius: 4px 4px 90px 4px;
      background: linear-gradient(93.83deg, rgba(199, 177, 254, 0.4) 7.27%, rgba(255, 212, 216, 0.4) 105.33%);
    }
  }
}
</style>
